import { parse, GraphQLSchema } from 'graphql';
import { compileToIR, CompilerOptions, } from '../../..';
import { loadSchema } from '../../../../loading';

export const starWarsSchema = loadSchema(require.resolve('../../../../../../common-test/fixtures/starwars/schema.json'));

export function compile(source: string, schema: GraphQLSchema = starWarsSchema, options: CompilerOptions = {}) {
  const document = parse(source);
  return compileToIR(schema, document, options);
}
